#!/usr/bin/perl

use lib '/usr/lib/libDrakX';
use strict;

BEGIN { push @::textdomains, 'drakcluster' }

use standalone;

use common;
use ugtk2 qw(:wrappers :create);
use interactive::gtk;
use cluster_commonconf;

my $window_splash = Gtk2::Window->new('popup');
$window_splash->signal_connect(delete_event => \&quit_global);
$window_splash->set_position('center_always');
my $filename = "/usr/share/pixmaps/cluster/drakcluster-splash.png";
my $image = Gtk2::Image->new_from_file ($filename);
$window_splash->add($image);
$window_splash->show_all;
gtkflush();


use drakcluster::actions;
use drakcluster::nodes;
use drakcluster::users;
use drakcluster::server_conf_ui;
use drakcluster::pxe_conf;
use drakcluster::common;
use drakcluster::menu;
use interface_cluster;


#my $nodes = {
#    map_index { 
#	"node$_" => { 
#          name => "node$_",
#	  partition => "part" . int($::i / 4), 
#	  group => "group" . $::i % 4,
#	 }
#    } 1 .. 20
#};

my $nodes = interface_cluster::get_node_list();

#my $users = {
#    map_index { "user$::i" => { "part" . int($::i / 4) => 1 } } 1 .. 10
#};

my $users = interface_cluster::get_users_list();

#my $partitions = [ qw(part0 part1 part2 part3) ];

my $partitions = interface_cluster::get_partition_list();

#my $group = [ qw(group0 group1 group2) ];

my $group = interface_cluster::get_group_list();

my $categories = { 
		  partition => $partitions, 
		  group => $group,
		 };

my @items = get_items("newbee");

################################################################################

$::in = interactive::gtk->new;
#if ($ARGV[0] eq "expert") {
#  $::in->ask_warn('', N("\n\tWARNING !!\n
#You launch drakcluster in expert mode
#You can BREAK your conf !
#Use with care please\n"));
#  @items = get_items("expert");
#} else { 
#  @items = get_items("newbee");
#}

my $w = ugtk2->new('drakcluster');

my $users_notebook = Gtk2::VBox->new;
my $notebook_widget = Gtk2::Notebook->new;
my $factory = Gtk2::ItemFactory->new('Gtk2::MenuBar', '<main>', undef);
$factory->create_items('menu', @items);
my $menu = $factory->get_widget('<main>');


my @notebook_callbacks;
$notebook_widget->signal_connect(switch_page => sub { $notebook_callbacks[$_[2]]->() });
{
    my $box = Gtk2::VBox->new;
    my $tree_view = drakcluster::nodes::create($nodes);
#remove unused menu
#    gtkpack_($box, 0, $menu);
    gtkpack($box, create_scrolled_window($tree_view));
    drakcluster::nodes::handle_selection_change($tree_view, $nodes, 
						my $selection = [], my $buttons_set_sensitive = [],
						drakcluster::actions::popup_menus($categories),
						sub { drakcluster::users::create($users_notebook, $users, $partitions) },
						);

    (my $buttons, @$buttons_set_sensitive) = drakcluster::actions::create_buttons($selection);
    $_->() foreach @$buttons_set_sensitive;
    gtkpack_($box, 0, $buttons);

# 5000 -> 5 seconds = refresh rate
# 30000 -> 30 seconds

    Glib::Timeout->add(30000, sub { drakcluster::nodes::update_nodes_up($tree_view, $nodes); 1 });

    push @notebook_callbacks, sub {};
    ugtk2::add2notebook($notebook_widget, N("Nodes"), $box);
}

# add a test to test maui presence
if (-f "/usr/bin/maui") {
  {
    drakcluster::users::create($users_notebook, $users, $partitions);
    push @notebook_callbacks, sub {};
    ugtk2::add2notebook($notebook_widget, N("Users"), $users_notebook);
  }
}

# remove now use drakpxelinux
#{
#    my $pxe_conf = drakcluster::pxe_conf::read();
#    push @notebook_callbacks, sub {};
#    ugtk2::add2notebook($notebook_widget, N("PXE Configuration"), drakcluster::pxe_conf::create($pxe_conf));
#}


# remove, not more needed
#{
#    my $server_conf = drakcluster::server_conf::read();
#    push @notebook_callbacks, sub {};
#    ugtk2::add2notebook($notebook_widget, N("Server Configuration"), drakcluster::server_conf_ui::create($server_conf));
#}

#{
#    my $box = gtkpack_(Gtk2::HBox->new,
#		       1, '',
#		       0, gtkpack__(Gtk2::VBox->new,
#				    map { 
#					my ($txt, $f) = @$_;
#					gtksignal_connect(Gtk2::Button->new($txt), clicked => $f);
#				    } drakcluster::actions::commands_list()),
#		       1, '');
#    ugtk2::add2notebook($notebook_widget, N("Administration"), $box);
#    push @notebook_callbacks, sub {};
#}


gtkadd(gtkset_size_request($w->{window}, 640, 560), $notebook_widget);
$window_splash->destroy;

$w->main;

